---
title: tabindex
slug: Web/HTML/Global_attributes/tabindex
tags:
  - Global attributes
  - HTML
  - Reference
---
<div>{{HTMLSidebar("Global_attributes")}}</div>

<p><span class="seoSummary">The <strong><code>tabindex</code></strong> <a href="/en-US/docs/Web/HTML/Global_attributes">global attribute</a> indicates that its element can be focused, and where it participates in sequential keyboard navigation (usually with the <kbd>Tab</kbd> key, hence the name).</span></p>

<div>{{EmbedInteractiveExample("pages/tabbed/attribute-tabindex.html","tabbed-standard")}}</div>

<p class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples </a> and send us a pull request.</p>

<p>It accepts an integer as a value, with different results depending on the integer's value:</p>

<ul>
 <li>A <em>negative value</em> (usually <code>tabindex="-1"</code>) means that the element is not reachable via sequential keyboard navigation, but could be focused with Javascript or visually by clicking with the mouse. It's mostly useful to create accessible widgets with JavaScript.

  <div class="note">
  <p>A negative value is useful when you have off-screen content that appears on a specific event. The user won't be able to focus any element with a negative <code>tabindex</code> using the keyboard, but a script can do so by calling the <code>focus()</code> <a href="/en-US/docs/Web/API/HTMLElement/focus">method</a>.</p>
  </div>
 </li>
 <li><code>tabindex="0"</code> means that the element should be focusable in sequential keyboard navigation, after any positive tabindex values and its order is defined by the document's source order.</li>
 <li>A <em>positive value</em> means the element should be focusable in sequential keyboard navigation, with its order defined by the value of the number. That is, <code>tabindex="4"</code> is focused before <code>tabindex="5"</code> and <code>tabindex="0"</code>, but after <code>tabindex="3"</code>. If multiple elements share the same positive <code>tabindex</code> value, their order relative to each other follows their position in the document source. The maximum value for <code>tabindex</code> is 32767. If not specified, it takes the default value 0.
  <div class="warning">
  <p>Avoid using <code>tabindex</code> values greater than 0. Doing so makes it difficult for people who rely on assistive technology to navigate and operate page content. Instead, write the document with the elements in a logical sequence.</p>
  </div>
 </li>
</ul>

<p>If you set the <code>tabindex</code> attribute on a {{htmlelement("div")}}, then its child content cannot be scrolled with the arrow keys unless you set <code>tabindex</code> on the content, too. <a href="https://jsfiddle.net/jainakshay/0b2q4Lgv/">Check out this fiddle to understand the scrolling effects of <code>tabindex</code></a>.</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Avoid using the <code>tabindex</code> attribute in conjunction with non-<a href="/en-US/docs/Web/Guide/HTML/Content_categories#Interactive_content">interactive content</a> to make something intended to be interactive focusable by keyboard input. An example of this would be using a {{HTMLElement("div")}} element to describe a button, instead of the {{HTMLElement("button")}} element.</p>

<p>Interactive components authored using non-interactive elements are not listed in the <a href="/en-US/docs/Learn/Accessibility/What_is_accessibility#Accessibility_APIs">accessibility tree</a>. This prevents assistive technology from being able to navigate to and manipulate those components. The content should be semantically described using interactive elements ({{HTMLElement("a")}}, {{HTMLElement("button")}}, {{HTMLElement("details")}}, {{HTMLElement("input")}}, {{HTMLElement("select")}}, {{HTMLElement("textarea")}}, etc.) instead. These elements have built-in roles and states that communicate status to the accessibility that would otherwise have to be managed by <a href="/en-US/docs/Web/Accessibility/ARIA">ARIA</a>.</p>

<ul>
 <li><a href="https://developer.paciellogroup.com/blog/2014/08/using-the-tabindex-attribute/">Using the tabindex attribute | The Paciello Group</a></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', "interaction.html#attr-tabindex", "tabindex")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>No change from latest snapshot, {{SpecName('HTML5.1')}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', "editing.html#the-tabindex-attribute", "tabindex")}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td>Snapshot of {{SpecName('HTML WHATWG')}}, no change from {{SpecName('HTML5 W3C')}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "editing.html#attr-tabindex", "tabindex")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Snapshot of {{SpecName('HTML WHATWG')}}. From {{SpecName("HTML4.01")}}, the attribute is now supported on all elements (global attributes).</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML4.01', 'interact/forms.html#adef-tabindex', 'tabindex')}}</td>
   <td>{{Spec2('HTML4.01')}}</td>
   <td>Only supported on {{HTMLElement("a")}}, {{HTMLElement("area")}}, {{HTMLElement("button")}}, {{HTMLElement("input")}}, {{HTMLElement("object")}}, {{HTMLElement("select")}}, and {{HTMLElement("textarea")}}.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("html.global_attributes.tabindex")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>All <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a></li>
 <li>{{domxref("HTMLElement.tabIndex")}} that reflects this attribute</li>
 <li>Accessibility problems with tabindex: see <a href="http://adrianroselli.com/2014/11/dont-use-tabindex-greater-than-0.html">Don’t Use Tabindex Greater than 0</a> by Adrian Roselli</li>
</ul>
